CON

  _CLKMODE            = XTAL1 + PLL16X
  _XINFREQ            = 5_000_000

  'Full Duplex Serial Pin Assignments
  TX                  = 30
  RX                  = 31

  'Full Duplex Serial Driver Constants  
  COMM_MODE           = 0
  COMM_BAUD_RATE      = 115_200

VAR

  'Global variables for the IntegerSquareRoot method
  BYTE bIntSqRt_C
  BYTE bIntSqRt_Z
  BYTE bIntSqRt_J
  BYTE bIntSqRt_Y2
  
  WORD wIntSqRt_B
  WORD wIntSqRt_X
  WORD wIntSqRt_I
  WORD wIntSqRt_Y2

  LONG lIntSqRt_Y2

OBJ

  Terminal:     "FullDuplexSerial"
    
PUB Main | SquareRoot

  'Start FullDuplexSerial
  Terminal.Start(RX, TX, COMM_MODE, COMM_BAUD_RATE)
  WAITCNT(CNT + (1 * CLKFREQ))

  SquareRoot := IntegerSquareRoot(603729)
  Terminal.Dec(SquareRoot)

PUB IntegerSquareRoot(IntSqRt_A)

  {
  \param a find square root of this number
  \return sqrt(a - 1) < returnvalue <= sqrt(a)
  }

  wIntSqRt_B := IntSqRt_A >> 16
  bIntSqRt_C := wIntSqRt_B >> 8
  wIntSqRt_X := 0
  bIntSqRt_Z := 0
  
  bIntSqRt_J := $8

  REPEAT WHILE bIntSqRt_J

    bIntSqRt_Z |= bIntSqRt_J
    bIntSqRt_Y2 := bIntSqRt_Z * bIntSqRt_Z
    
    IF bIntSqRt_Y2 > bIntSqRt_C
    
      bIntSqRt_Z ^= bIntSqRt_J

    bIntSqRt_J >>= 1  
  
  wIntSqRt_X := bIntSqRt_Z << 4   

  wIntSqRt_I := $8

  REPEAT WHILE wIntSqRt_I

    wIntSqRt_X |= wIntSqRt_I
    wIntSqRt_Y2 := wIntSqRt_X * wIntSqRt_X
    
    IF wIntSqRt_Y2 > wIntSqRt_B
    
      wIntSqRt_X ^= wIntSqRt_I

    wIntSqRt_I >>= 1   
  
  wIntSqRt_X <<= 8
  
  wIntSqRt_I := $80

  REPEAT WHILE wIntSqRt_I

    wIntSqRt_X |= wIntSqRt_I
    lIntSqRt_Y2 := wIntSqRt_X * wIntSqRt_X
    
    IF lIntSqRt_Y2 > IntSqRt_A
    
      wIntSqRt_X ^= wIntSqRt_I

    wIntSqRt_I >>= 1  

  RETURN wIntSqRt_X
  